clear all
close all
clc

load Vsolution
umax = 10;
umin = -2;
R = size(Vsol);

run('C:\Users\dan\Desktop\HJB Toolbox\Examples\addPathToKernel');

timedata = 0:5:2000;
%timedata = 0:10:35000;


% figure
% for k = 1:length(Vsol)
% surf(Vsol(:,:,k))
% view([-180 0]);
% pause
% end

for k = 1:R(1)
    for m = 1:R(1)
        buffer = Vsol(k,m,:);
        
        count = 0;
        myend = 0;
        while(count < R(3) && myend == 0)
            count = count + 1;
            myend = (buffer(count)<0);
        end
        
        if count == 1
            V(k,m) = 0;
        elseif count > R(3)-1
            V(k,m) = 2000;
        else
        y1 = buffer(count-1);
        y2 = buffer(count);
        x1 = timedata(count-1);
        x2 = timedata(count);
        
        sl = (y2-y1)/(x2-x1);
        bb = y1-sl*x1;
        V(k,m) = -bb/sl;
        end
    end
end
load rawtargetsetdata
K = linspace(g.axis(1),g.axis(2),R(1));
NA = linspace(g.axis(3),g.axis(4),R(2));
% plot(Xdata,Ydata,'k','Linewidth',3)
% hold on
surf(g.xs{1},g.xs{2},V')



for i = 1:2
    [ derivL{i}, derivR{i} ] = feval(schemeData.derivFunc, g, V', i);
    derivC{i} = 0.5 * (derivL{i} + derivR{i});
    derivC{i} = derivC{i};
end



load myaveragecurrentsinterp
for k = 1:40
    NAcurrents(:,:,k) = 1;
    Kcurrents(:,:,1) = 1;
end

[Kavs Naavs] = findaveragecurrentsdontswitch(g,Kcurrents,NAcurrents);
RR = size(Kavs);

siz = 20/(RR(3)-1);
uposs = -10:siz:10;

buf1 = zeros(length(derivC{1}),length(derivC{1}),RR(3));
buf2 = buf1;
for k = 1:length(uposs)
    if -10+siz*(k -1) <=umax+.001   &&  -10+siz*(k -1) >=umin -.001
    buf1(:,:,k) = derivC{1};
    buf2(:,:,k) = derivC{2};
    else
    buf1(:,:,k) = Kavs(:,:,k)*1000;
    buf2(:,:,k) = Naavs(:,:,k)*1000;
    end
end


%with control



%%%%%Script for double checking min energy/min time solution
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Z = buf1.*Kavs + buf2.*Naavs;
for j = 1:201
    for k = 1:201
        buffer = zeros(401,1);
        for m = 1:401
            buffer(m) = Z(j,k,m);
        end
        
        b = find(buffer == min(buffer(:)));
        
        if length(b)>1
            ttttt = 5;
        end
        
        ens = ((b-201)/20);
         
        [sbuf,orig] = sort(ens.^2);
        
         input(j,k) = ens(orig(1));
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%55


[A,myU] = min(buf1.*Kavs + buf2.*Naavs,[],3);

        

%%%without control
%  newbuf = buf1.*Kavs + buf2.*Naavs;
%  A = (newbuf(:,:,51));



[fx1 fx2] = EP_f_2d(g);
fx1 = fx1;
fx2 = fx2;
check = 1+derivC{1}.*fx1+derivC{2}.*fx2 + A;
figure
surf(g.xs{1},g.xs{2},check)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%55

for k = 1:length(myU)
    for j = 1:length(myU)
        input(k,j) = uposs(myU(k,j));
    end
end





break

%turn off when in TS%%%%
load rawtargetsetdata
Xdata1 = Xdata;
Ydata1 = Ydata;
load targetset15000
Xdata2 = Xdata;
Ydata2 = Ydata;
load targetset15000safe
aa = 1;
bb = 1;
xrange = g.xs{1}(:,1)';
yrange = g.xs{2}(1,:);
for j = xrange
    for k = yrange
        if signeddistanceforrawtargetset([Xdata1' Ydata1'], j, k) < 0
            if (signeddistance([Xdata2' Ydata2'], j, k) < 0 && signeddistance([Xdata' Ydata'], j, k) >  0)
            
            else
            input(bb,aa) = 0;
            end

        end
        aa = aa+1;
    end
    bb = bb+1;
    aa = 1;
end




V = V/1000;
subplot(1,2,1)
pcolor(g.xs{1},g.xs{2},V')
shading interp
xlabel('$\rm{[K]_o}$','Interpreter','Latex','Fontsize',22)
ylabel('$\rm{[Na]_i}$','Interpreter','Latex','Fontsize',22)
colorbar
load targetset15000safe
hold on
plot(Xdata,Ydata,'k','LineWidth',3)
 load rawtargetsetdata
 plot(Xdata,Ydata,'--k','LineWidth',3)
set(gca,'FontSize',14)
%title('$\mathcal{V}(x)$','Interpreter','Latex','Fontsize',22)

tt = colorbar('peer',gca);
 h_bar1 = findobj(gcf,'Tag','Colorbar');
 initpos1 = get(h_bar1,'Position');
 set(h_bar1, ...
   'Position',[initpos1(1)+.09 initpos1(2)...
      initpos1(3)*0.7 initpos1(4)*0.7]);
 set(get(tt,'ylabel'),'String','$\mathcal{V}_t(x)$','Interpreter','Latex','Fontsize',16);





subplot(1,2,2)
% plot(Xdata,Ydata,'k','Linewidth',3)
% hold on
pcolor(g.xs{1},g.xs{2},input);

load targetset15000safe
hold on
plot(Xdata,Ydata,'k','LineWidth',3)
load rawtargetsetdata
plot(Xdata,Ydata,'--k','LineWidth',3)
xlabel('$\rm{[K]_o}$','Interpreter','Latex','Fontsize',22)
ylabel('$\rm{[Na]_i}$','Interpreter','Latex','Fontsize',22)
set(gca,'FontSize',14)
shading interp
%title('$u^*(x)$','Interpreter','Latex','Fontsize',22)
axis([5 18.5 14.3 20.9])

rr = colorbar('peer',gca);
 h_bar = findobj(gcf,'Tag','Colorbar');
 h_bar = h_bar(1);
 initpos = get(h_bar,'Position');
 %intpos = ans;
 set(h_bar, ...
   'Position',[initpos(1)+.09  initpos(2)...
       initpos(3)*0.7   initpos(4)*0.7]);
 set(get(rr,'ylabel'),'String','$u^* \quad (\mu \rm{A}/ \mu \rm{F})$ ','Interpreter','Latex','Fontsize',16);





