function[ret] =  signeddistance(curve,xpoints,ypoints)

%%%%%%%%%%%%%%%%%%
%Give distance from point to 2D curve

%curve = 2 column matrix if x-y pairs for points on the curve

%point = x-y pair for point's distance to be determined

%Sign is negative for points to left of curve, positive for
%points to the right
ret = zeros(size(xpoints));
for m = 1:length(xpoints)
    for n = 1:length(xpoints)
        point(1) = xpoints(m,n);
        point(2) = ypoints(m,n);


dists = zeros(size(curve));
for k = 1:length(curve)
    dists(k,1) = curve(k,1)-point(1);
    dists(k,2) = curve(k,2)-point(2);
end

D = sqrt(dists(:,1).^2+dists(:,2).^2);

[C,I] = min(D);

if point(1) >7.14  %%%%%%%%%

if dists(I,1) > 0
    C = -C; 
else
    C = C;
end

else%%%%%%
    if dists(I,2) > 0%%%%%%%
        C = C;%%%
    else%%%
        C = -C;%%%
    end%%%
end
    
    
    
C = C+0;

ret(m,n) = C;
    end
end


    